SoNodeEngine(3)

NAME
SoNodeEngine - SoNodeEngine is the base class for Coin node engines.

SYNOPSIS

#include <Inventor/engines/SoNodeEngine.h>

Inherits SoNode.

Inherited by SoVRMLInterpolator, and SoVRMLTimeSensor.

  Public Member Functions
void evaluateWrapper (void)
virtual int getOutputs (SoEngineOutputList &l) const
SoEngineOutput * getOutput (const SbName &outputname) const
SbBool getOutputName (const SoEngineOutput *output, SbName &outputname) const
virtual const SoEngineOutputData * getOutputData (void) const =0
SbBool isNotifying (void) const
virtual void notify (SoNotList *nl)
virtual void writeInstance (SoOutput *out)

  Static Public Member Functions
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)

  Protected Member Functions
SoNodeEngine (void)
virtual ~SoNodeEngine (void)
virtual void evaluate (void)=0
virtual SbBool readInstance (SoInput *in, unsigned short flags)
virtual void inputChanged (SoField *which)
void writeOutputTypes (SoOutput *out)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

SoNodeEngine is the base class for Coin node engines. Node engines have the same functionality as normal engines, except that they inherit SoNode, which makes it possible to insert node engines in the scene graph.

The main rationale for this class is to simplify the implementation of VRML interpolator nodes, which are in a sense engines embedded in the shape of ordinary nodes.

This abstract superclass will likely be of no interest to the Coin application programmer, and you can safely ignore it.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Constructor & Destructor Documentation

  SoNodeEngine::SoNodeEngine (void) [protected]
Default constructor.

  SoNodeEngine::~SoNodeEngine (void) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoNodeEngine::getClassTypeId (void) [static]

  void SoNodeEngine::evaluateWrapper (void)
Triggers an engine evaluation.

  int SoNodeEngine::getOutputs (SoEngineOutputList & l) const [virtual]
Adds all outputs to list. Returns the number of outputs added to the list.

  SoEngineOutput * SoNodeEngine::getOutput (const SbName & outputname) const
Returns the output with name outputname, or NULL if no such output exists.

  SbBool SoNodeEngine::getOutputName (const SoEngineOutput * output, SbName & outputname) const
Sets outputname to the name of output. Returns FALSE if no such output is contained within the engine instance.

  const SoEngineOutputData * SoNodeEngine::getOutputData (void) const [pure virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implemented in SoVRMLColorInterpolator, SoVRMLCoordinateInterpolator, SoVRMLInterpolator, SoVRMLNormalInterpolator, SoVRMLOrientationInterpolator, SoVRMLPositionInterpolator, SoVRMLScalarInterpolator, and SoVRMLTimeSensor.

  SbBool SoNodeEngine::isNotifying (void) const
Returns whether we're in a notification process. This is needed to avoid double notification when an engine enables outputs during inputChanged().

  void SoNodeEngine::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Reimplemented in SoVRMLTimeSensor.

  void SoNodeEngine::writeInstance (SoOutput * out) [virtual]
Writes all the fields contained in this instance to the output stream within out.

This method is solely called from the write methods of fields.

Either from SoField if the write is done because of a field-to-field connection, or from one of the fields which may actually write SoFieldContainer instances, i.e. SoSFNode, SoMFNode, SoSFEngine, SoMFEngine, SoSFPath and SoMFPath.

This method, in addition to the ordinary write() method of SoNode, needs to be present since the fields don't have a write action instance in their writeValue() method, and writeInstance() will create a new SoWriteAction and call continueToApply() on it.

Reimplemented from SoNode.

  void SoNodeEngine::evaluate (void) [protected], [pure virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

  SbBool SoNodeEngine::readInstance (SoInput * in, unsigned short flags) [protected], [virtual]
This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

TRUE or FALSE is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning FALSE.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

  void SoNodeEngine::inputChanged (SoField * which) [protected], [virtual]
Called when an input is changed. The default method does nothing, but subclasses may override this method to do the The Right Thing when a specific field is changed.

Reimplemented in SoVRMLTimeSensor.

  const SoFieldData ** SoNodeEngine::getFieldDataPtr (void) [static], [protected]
Returns the SoFieldData class which holds information about inputs in this engine.

  const SoEngineOutputData ** SoNodeEngine::getOutputDataPtr (void) [static], [protected]
Returns the SoEngineOutputData class which holds information about the outputs in this engine.

  void SoNodeEngine::writeOutputTypes (SoOutput * out) [protected]
Writes the types of engine outputs for extension engines (i.e. engines not built in to Coin).

Author

Generated automatically by Doxygen for Coin from the source code.